* Franchino, Fabio, Mark A. Kayser, and Christopher Wratil (2021) `Electoral Competitiveness and Responsiveness: Rational Anticipation in the EU Council' Journal of European Public Policy.

* STEP 1.	Production of the variable Expected government duration

************************* Run government survival models
pause on
**** Import final dataset
use final.dta, clear
sort country_name edate sdate

***************  Expected government duration – survival model using all countries and post-1990 time period (FKW3)
* Weibull ATF model - as in Chiba et al. p. 54 Table 3- Dissolution terminations without selection
drop if edate<date("01jan1990","DMY")
stset govdurat, failure(censor_discelec==1)
streg  minor govdiv prop_prevgovparties enp sysanmax log_max_govdurat, d(weibull) nohr time
predict iteration0
keep cabinet_id iteration0
save iteration, replace
* Bootstrap Weibull ATF model - as in Chiba et al. p. 54 Table 3- Dissolution terminations without selection
set seed 12345
forvalues a = 1/2100 {
use final.dta, clear
sort country_name edate sdate
drop if edate<date("01jan1990","DMY")
stset govdurat, failure(censor_discelec==1)
bsample
streg  minor govdiv prop_prevgovparties enp sysanmax log_max_govdurat, d(weibull) nohr time
predict iteration`a' if e(sample)
collapse iteration`a', by(cabinet_id)
merge 1:1 cabinet_id using iteration.dta, nogen
order iteration`a', last
order cabinet_id iteration0
save iteration, replace
}
sort cabinet_id
xpose, clear var  /* reorganize iterations obs */
forvalues b = 1/2100 {
forvalues a = 1/355 {
replace v`a'=v`a'[_n+1] if v`a'==.
replace v`a'= . if v`a'==v`a'[_n-1]
}
}
keep in 1/1002
xpose, clear

* Generate duration measure and uncertainty
merge 1:1 cabinet_id using final
* pause /* check if 355 matched - type q to continue*/
drop _merge
order iteration*, last
egen FKW3expdurat=rowmean(iteration1-iteration1000)
egen FKW3expdurat_sem=rowsd(iteration1-iteration1000)
replace FKW3expdurat_sem=FKW3expdurat_sem/sqrt(1000)
order FKW3expdurat FKW3expdurat_sem, after(govdurat)
replace FKW3expdurat = max_govdurat if FKW3expdurat  > max_govdurat /* trim expdurat to max_govdurat if higher */

* Delete early obs and drop ad rename var
sort country_name edate sdate
order cabinet_id, after(sdate)
keep country_name-enddate FKW3expdurat FKW3expdurat_sem max_govdurat cabinet_name caretaker
gen cutoff = date("01jan1990", "DMY")
drop if sdate<cutoff
drop cutoff
do "rename country_name"

* Gen var and save dataset
generate DateofProposal = sdate
order DateofProposal, after(sdate)
format DateofProposal  %tdDDmonCCYY
sort Country sdate

save FKW3.dta, replace
